include \masm32\include\masm32rt.inc
.686
include TIMERS.ASM

debug macro args:vararg
	pushad
	% print args
	popad
endm

wxprintf proto C :dword, :dword,:VARARG
  
     CTEXT MACRO text:VARARG
            LOCAL TxtName
              .data
               TxtName BYTE text,0
              .code
            EXITM <ADDR TxtName>
     ENDM        
        
.data?
szBuff db 1024 dup(?)       

.data
delim db "Hey %s you %s? Me, i'm %s.",0

.code
start:

; test
invoke wsprintf,addr szBuff,addr delim,CTEXT("how are"),CTEXT("doing"), CTEXT("good")
debug addr szBuff, 10
invoke wsprintf,addr szBuff,addr delim,CTEXT("how are"),CTEXT("doing"), CTEXT("good")
debug addr szBuff, 10, 10

debug "Timing...", 10

; time wsprintf
LOOP_COUNT EQU 1000000
counter_begin LOOP_COUNT, HIGH_PRIORITY_CLASS
invoke wsprintf,addr szBuff,addr delim,CTEXT("how are"),CTEXT("doing"), CTEXT("good")
counter_end
debug "wsprintf: "
debug <ustr$(eax)>, 10

; time wxprintf
LOOP_COUNT EQU 1000000
counter_begin LOOP_COUNT, HIGH_PRIORITY_CLASS
invoke wxprintf,addr szBuff,addr delim,CTEXT("how are"),CTEXT("doing"), CTEXT("good")
counter_end
debug "wxprintf: "
debug <ustr$(eax)>, 10, 10

inkey "Press any key...", 10

invoke ExitProcess,0

; wxprintf
OPTION PROLOGUE:NONE
OPTION EPILOGUE:NONE
wxprintf proc C iBuf,iSep,iData:VARARG
    mov edi, dword ptr [esp+8]
    mov esi, dword ptr [esp+12]
    mov edx,12
@Bx:
    cmp word ptr [esi],'s%'
    je @F
    mov al,byte ptr [esi]		
    inc esi	
    mov [edi], al	
    inc edi
    test al, al
    jnz @Bx
    ret; 8
    @@: 
    add edx,4
    mov ecx,dword ptr [esp+edx]
    add esi,2 
    @@:
    mov al,byte ptr [ecx]		
    test al, al
    jz @Bx
    inc ecx
    mov [edi], al
    inc edi	
    jmp @B	
wxprintf endp
OPTION PROLOGUE:PrologueDef
OPTION EPILOGUE:EpilogueDef

end start